﻿#pragma once

#if _WIN32 || _WIN64

#include "../Application.h"
#include "Win32Platform.h"


class FWin32Application : public FApplication
{
public:
    static int Run(HINSTANCE hInstance, int nCmdShow);

    virtual bool Init() override;
    virtual void Update() override;
    virtual void Destroy() override;

    void SetAppInstance(HINSTANCE hInstance) { AppInstance = hInstance; }
    HINSTANCE GetAppInstance() const { return AppInstance; }

    void    SetAppCmdShow(int InCmdShow) { AppCmdShow = InCmdShow; }
    int     GetAppCmdShow() const { return AppCmdShow; }
    
    UINT GetWidth() const           { return AppWidth; }
    UINT GetHeight() const          { return AppHeight; }
    const WCHAR* GetAppTitle() const   { return AppTitle.c_str(); }
    void SetAppTitle(const WCHAR* Title)  { AppTitle = Title; }

    void SetWindowSize(UINT Width, UINT Height);
protected:
    virtual void ParseCommandLine() override;
    virtual void InitializeWindow();
    virtual void InitializePipeline();
    
    static LRESULT CALLBACK WindowProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

protected:
    HINSTANCE       AppInstance = nullptr;
    HWND            Hwnd        = nullptr;
    std::wstring    AppTitle;
    UINT            AppWidth    =   800;
    UINT            AppHeight   =   600;
    int             AppCmdShow  =   0;
};

#endif